// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateSearchConfiguration.vsl in andromda-spring-cartridge.
//
package fr.ifremer.adagio.core.dao;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

/**
 * Contains configuration parameters for a <code>CriteriaSearch</code>.
 *
 * @author Stefan Reichert
 * @author Peter Friese
 */
public class CriteriaSearchConfiguration
{
    /**
     * Constructs a new CriteriaSearchConfiguration instance with all fields set to
     * either <code>null</code> or <code>false</code>.
     */
    public CriteriaSearchConfiguration()
    {
        this.forceEagerLoading = false;
        this.firstResult = null;
        this.fetchSize = null;
        this.maximumResultSize = null;
    }

    /**
     * If a parameter refers to a childEntity and <code>forceEagerLoading</code> is
     * <code>true</code>, the childEntity is always loaded. If <code>forceEagerLoading</code> is
     * <code>false</code>, the loading depends on the persister-configuration of the parentEntity.
     */
    private boolean forceEagerLoading;

    /**
     * Returns whether or not eager loading is enabled.
     *
     * @return <code>true</code> if eager loading is enabled, <code>false</code> otherwise
     */
    public boolean isForceEagerLoading()
    {
        return this.forceEagerLoading;
    }

    /**
     * Sets whether or not eager loading is to be enabled.
     *
     * @param forceEagerLoadingIn <code>true</code> if eager loading is to be enabled, <code>false</code> otherwise
     */
    public void setForceEagerLoading(boolean forceEagerLoadingIn)
    {
        this.forceEagerLoading = forceEagerLoadingIn;
    }

    /**
     * The first result to retrieve.
     */
    private Integer firstResult;

    /**
     * Gets the first result to retrieve.
     *
     * @return the first result to retrieve
     */
    public Integer getFirstResult()
    {
        return this.firstResult;
    }

    /**
     * Sets the first result to retrieve.
     *
     * @param firstResultIn the first result to retrieve
     */
    public void setFirstResult(Integer firstResultIn)
    {
        this.firstResult = firstResultIn;
    }

    /**
     * The fetch size.
     */
    private Integer fetchSize;

    /**
     * Gets the fetch size.
     *
     * @return the fetch size
     */
    public Integer getFetchSize()
    {
        return this.fetchSize;
    }

    /**
     * Sets the fetch size.
     *
     * @param fetchSizeIn the fetch size
     */
    public void setFetchSize(Integer fetchSizeIn)
    {
        this.fetchSize = fetchSizeIn;
    }

    /**
     * If <code>maximumResultSize</code> is not <code>null</code> it limits the maximum size of
     * the resultList.
     */
    private Integer maximumResultSize;

    /**
     * Gets the maximum size of the search result.
     *
     * @return the maximum size of the search result.
     */
    public Integer getMaximumResultSize()
    {
        return this.maximumResultSize;
    }

    /**
     * Sets the maximum size of the result.
     *
     * @param maximumResultSizeIn A number indicating how many results will be returned.
     */
    public void setMaximumResultSize(Integer maximumResultSizeIn)
    {
        this.maximumResultSize = maximumResultSizeIn;
    }
}