// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.vessel;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import java.io.Serializable;
import java.util.Date;

/**
 * Période d'appartenance d'un navire à un armateur (période d'armement).
 * Nombre de lignes : 25600
 */
// HibernateEntity.vsl annotations merge-point
public abstract class VesselOwnerPeriod
    implements Serializable, Comparable<VesselOwnerPeriod>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -4523764948850094855L;

    private VesselOwnerPeriodPK vesselOwnerPeriodPk;

    /**
     * Get the composite primary key identifier class
     * @return vesselOwnerPeriodPk
     */
    public VesselOwnerPeriodPK getVesselOwnerPeriodPk()
    {
        return this.vesselOwnerPeriodPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param vesselOwnerPeriodPkIn
     */
    public void setVesselOwnerPeriodPk(VesselOwnerPeriodPK vesselOwnerPeriodPkIn) {
        this.vesselOwnerPeriodPk = vesselOwnerPeriodPkIn;
    }

    // Generate 2 attributes
    /**
     * 
     * @return this.startDateTime Date
     */
    public Date getStartDateTime()
    {
        return this.getVesselOwnerPeriodPk().getStartDateTime();
    }

    /**
     * 
     * @param startDateTimeIn Date
     */
    public void setStartDateTime(Date startDateTimeIn)
    {
        this.getVesselOwnerPeriodPk().setStartDateTime(startDateTimeIn);
    }

    private Date endDateTime;

    /**
     * 
     * @return this.endDateTime Date
     */
    public Date getEndDateTime()
    {
        return this.endDateTime;
    }

    /**
     * 
     * @param endDateTimeIn Date
     */
    public void setEndDateTime(Date endDateTimeIn)
    {
        this.endDateTime = endDateTimeIn;
    }

    // Generate 2 associations
    private Vessel vessel;

    /**
     * Navire. Peut etre un navire de peche professionnel ou non, un navire océanographique, etc.
     * @return this.vessel Vessel
     */
    public Vessel getVessel()
    {
        return this.vessel;
    }

    /**
     * Navire. Peut etre un navire de peche professionnel ou non, un navire océanographique, etc.
     * @param vesselIn Vessel
     */
    public void setVessel(Vessel vesselIn)
    {
        this.vessel = vesselIn;
    }

    private VesselOwner vesselOwner;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Armateur (ou propri&#233;taire) de navire(s). Personne physique ou morale.
     * </p>
     * <p>
     * </p>
     * <p>
     * Dans le cas de pecheur &#224; pied ou groupement de navires, <i>VesselOwner</i>
     * permet aussi de porter les informations sur le pecheur &#224; pied, ou sur le
     * responsable du groupement de navire.
     * </p>
     * <p>
     * </p>
     * <p>
     * Nombre de lignes : 20900
     * </p>
     * </body>
     * </html>
     * @return this.vesselOwner VesselOwner
     */
    public VesselOwner getVesselOwner()
    {
        return this.vesselOwner;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * Armateur (ou propri&#233;taire) de navire(s). Personne physique ou morale.
     * </p>
     * <p>
     * </p>
     * <p>
     * Dans le cas de pecheur &#224; pied ou groupement de navires, <i>VesselOwner</i>
     * permet aussi de porter les informations sur le pecheur &#224; pied, ou sur le
     * responsable du groupement de navire.
     * </p>
     * <p>
     * </p>
     * <p>
     * Nombre de lignes : 20900
     * </p>
     * </body>
     * </html>
     * @param vesselOwnerIn VesselOwner
     */
    public void setVesselOwner(VesselOwner vesselOwnerIn)
    {
        this.vesselOwner = vesselOwnerIn;
    }

    /**
     * Returns <code>true</code> if the argument is an VesselOwnerPeriod instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof VesselOwnerPeriod))
        {
            return false;
        }
        final VesselOwnerPeriod that = (VesselOwnerPeriod)object;
        if (this.vesselOwnerPeriodPk == null || that.vesselOwnerPeriodPk == null || !this.vesselOwnerPeriodPk.equals(that.vesselOwnerPeriodPk))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.vesselOwnerPeriodPk == null ? 0 : this.vesselOwnerPeriodPk.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link VesselOwnerPeriod}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link VesselOwnerPeriod}.
         * @return new VesselOwnerPeriodImpl()
         */
        public static VesselOwnerPeriod newInstance()
        {
            return new VesselOwnerPeriodImpl();
        }

        /**
         * Constructs a new instance of {@link VesselOwnerPeriod}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param vessel Vessel
         * @param vesselOwner VesselOwner
         * @return newInstance
         */
        public static VesselOwnerPeriod newInstance(Vessel vessel, VesselOwner vesselOwner)
        {
            final VesselOwnerPeriod entity = new VesselOwnerPeriodImpl();
            entity.setVessel(vessel);
            entity.setVesselOwner(vesselOwner);
            return entity;
        }

        /**
         * Constructs a new instance of {@link VesselOwnerPeriod}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param endDateTime Date
         * @param vessel Vessel
         * @param vesselOwner VesselOwner
         * @return newInstance VesselOwnerPeriod
         */
        public static VesselOwnerPeriod newInstance(Date endDateTime, Vessel vessel, VesselOwner vesselOwner)
        {
            final VesselOwnerPeriod entity = new VesselOwnerPeriodImpl();
            entity.setEndDateTime(endDateTime);
            entity.setVessel(vessel);
            entity.setVesselOwner(vesselOwner);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(VesselOwnerPeriod o)
    {
        int cmp = 0;
        if (this.getVesselOwnerPeriodPk() != null)
        {
            cmp = this.getVesselOwnerPeriodPk().compareTo(o.getVesselOwnerPeriodPk());
        }
        else
        {
            if (this.getEndDateTime() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEndDateTime().compareTo(o.getEndDateTime()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// VesselOwnerPeriod.java merge-point
}