// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.vessel.feature.use;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.administration.programStrategy.AcquisitionLevel;
import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import java.io.Serializable;

/**
 * 
 */
// HibernateEntity.vsl annotations merge-point
public abstract class VesselUseFeaturesOrigin
    implements Serializable, Comparable<VesselUseFeaturesOrigin>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -8528373629610315228L;

    private VesselUseFeaturesOriginPK vesselUseFeaturesOriginPk;

    /**
     * Get the composite primary key identifier class
     * @return vesselUseFeaturesOriginPk
     */
    public VesselUseFeaturesOriginPK getVesselUseFeaturesOriginPk()
    {
        return this.vesselUseFeaturesOriginPk;
    }

    /**
     * Set the composite primary key identifier class
     * @param vesselUseFeaturesOriginPkIn
     */
    public void setVesselUseFeaturesOriginPk(VesselUseFeaturesOriginPK vesselUseFeaturesOriginPkIn) {
        this.vesselUseFeaturesOriginPk = vesselUseFeaturesOriginPkIn;
    }

    // Generate 0 attributes
    // Generate 3 associations
    private AcquisitionLevel acquisitionLevel;

    /**
     * Permet d'identifier le type de donnée ayant servi à consitituer l'information de
     * VesselUseFeatures (une marée, une vente, etc). Optionnel.
     * @return this.acquisitionLevel AcquisitionLevel
     */
    public AcquisitionLevel getAcquisitionLevel()
    {
        return this.acquisitionLevel;
    }

    /**
     * Permet d'identifier le type de donnée ayant servi à consitituer l'information de
     * VesselUseFeatures (une marée, une vente, etc). Optionnel.
     * @param acquisitionLevelIn AcquisitionLevel
     */
    public void setAcquisitionLevel(AcquisitionLevel acquisitionLevelIn)
    {
        this.acquisitionLevel = acquisitionLevelIn;
    }

    private Program program;

    /**
     * Identifie le progamme d'origine, ayant servi à constituer les caractéristiques
     * VesselUseFeatures (par Copier/Coller, consolidation, croisement, etc).
     * @return this.program Program
     */
    public Program getProgram()
    {
        return this.program;
    }

    /**
     * Identifie le progamme d'origine, ayant servi à constituer les caractéristiques
     * VesselUseFeatures (par Copier/Coller, consolidation, croisement, etc).
     * @param programIn Program
     */
    public void setProgram(Program programIn)
    {
        this.program = programIn;
    }

    private VesselUseFeatures vesselUseFeatures;

    /**
     * Paramètres de mise en oeuvre du navire. Il peut s'agir de données d'observation comme de
     * données de
     * déclaration, mais liée à comment est utilisé le navire et dans quelles conditions.
     * Par exemple, pour les donénes d'observation :
     * • profondeur de mer au début de l'opération, en mètre,
     * • profondeur de mer à la fin de l'opération, en mètre,
     * • déroulement de l'opération (normal, anormal, etc.)
     * • état de la mer lors durant l'opération : échelle de 0 à 9 (4=agitée, etc)
     * • trait rectiligne (oui/non)
     * • cout en gazoil,
     * • nombre d'engin perdu,
     * • cout des pertes,
     * • etc.
     * Par exemple, pour les données de déclaration :
     * • temps de pêche,
     * • temps de route (qui peut aussi etre calculé à l'exploitation),
     * • nombre d'opérations,
     * • etc.
     * @return this.vesselUseFeatures VesselUseFeatures
     */
    public VesselUseFeatures getVesselUseFeatures()
    {
        return this.vesselUseFeatures;
    }

    /**
     * Paramètres de mise en oeuvre du navire. Il peut s'agir de données d'observation comme de
     * données de
     * déclaration, mais liée à comment est utilisé le navire et dans quelles conditions.
     * Par exemple, pour les donénes d'observation :
     * • profondeur de mer au début de l'opération, en mètre,
     * • profondeur de mer à la fin de l'opération, en mètre,
     * • déroulement de l'opération (normal, anormal, etc.)
     * • état de la mer lors durant l'opération : échelle de 0 à 9 (4=agitée, etc)
     * • trait rectiligne (oui/non)
     * • cout en gazoil,
     * • nombre d'engin perdu,
     * • cout des pertes,
     * • etc.
     * Par exemple, pour les données de déclaration :
     * • temps de pêche,
     * • temps de route (qui peut aussi etre calculé à l'exploitation),
     * • nombre d'opérations,
     * • etc.
     * @param vesselUseFeaturesIn VesselUseFeatures
     */
    public void setVesselUseFeatures(VesselUseFeatures vesselUseFeaturesIn)
    {
        this.vesselUseFeatures = vesselUseFeaturesIn;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only take the identifiers of this entity into account when calculating the hash code.
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link VesselUseFeaturesOrigin}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link VesselUseFeaturesOrigin}.
         * @return new VesselUseFeaturesOriginImpl()
         */
        public static VesselUseFeaturesOrigin newInstance()
        {
            return new VesselUseFeaturesOriginImpl();
        }

        /**
         * Constructs a new instance of {@link VesselUseFeaturesOrigin}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param program Program
         * @param vesselUseFeatures VesselUseFeatures
         * @return newInstance
         */
        public static VesselUseFeaturesOrigin newInstance(Program program, VesselUseFeatures vesselUseFeatures)
        {
            final VesselUseFeaturesOrigin entity = new VesselUseFeaturesOriginImpl();
            entity.setProgram(program);
            entity.setVesselUseFeatures(vesselUseFeatures);
            return entity;
        }

        /**
         * Constructs a new instance of {@link VesselUseFeaturesOrigin}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param acquisitionLevel AcquisitionLevel
         * @param program Program
         * @param vesselUseFeatures VesselUseFeatures
         * @return newInstance VesselUseFeaturesOrigin
         */
        public static VesselUseFeaturesOrigin newInstance(AcquisitionLevel acquisitionLevel, Program program, VesselUseFeatures vesselUseFeatures)
        {
            final VesselUseFeaturesOrigin entity = new VesselUseFeaturesOriginImpl();
            entity.setAcquisitionLevel(acquisitionLevel);
            entity.setProgram(program);
            entity.setVesselUseFeatures(vesselUseFeatures);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(VesselUseFeaturesOrigin o)
    {
        int cmp = 0;
        if (this.getVesselUseFeaturesOriginPk() != null)
        {
            cmp = this.getVesselUseFeaturesOriginPk().compareTo(o.getVesselUseFeaturesOriginPk());
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// VesselUseFeaturesOrigin.java merge-point
}