// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.grouping;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import fr.ifremer.adagio.core.dao.referential.ObjectType;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * <html>
 * <head>
 * <style>
 * p {padding:0px; margin:0px;}
 * </style>
 * </head>
 * <body>
 * <p>
 * Une classification de regroupement ne traite que d’un seul type de
 * données du référentiel à la fois (<i>ObjectType</i>).
 * Il peut s’agir de regroupement sur les métiers, les lieux, les espèces,
 * etc.
 * </p>
 * <p>
 * En revanche, un même type de données du référentiel (ex : Métier) peut
 * avoir plusieurs classification de regroupement distinctes (DCR, Ifremer,
 * Natura 2000, …)
 * </p>
 * <p>
 * </p>
 * <p>
 * Une classification de regroupement peut contenir un ou plusieurs niveaux
 * de regroupement (<i>GroupingLevel</i>).
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class GroupingClassification
    implements Serializable, Comparable<GroupingClassification>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1320964232888392003L;

    // Generate 5 attributes
    private Integer id;

    /**
     * Identifiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Identifiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String label;

    /**
     * 
     * @return this.label String
     */
    public String getLabel()
    {
        return this.label;
    }

    /**
     * 
     * @param labelIn String
     */
    public void setLabel(String labelIn)
    {
        this.label = labelIn;
    }

    private String name;

    /**
     * 
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * 
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private String description;

    /**
     * 
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * 
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 5 associations
    private ObjectType objectType;

    /**
     * Liste des types d'objets qui peuvent etre associés à la photo ou à un fichier attaché. Cette
     * liste
     * ne peut pas etre modifiée par l'utilisateur.
     * généralement, il s'agit des noms des tables (en majuscule + underscore)
     * @return this.objectType ObjectType
     */
    public ObjectType getObjectType()
    {
        return this.objectType;
    }

    /**
     * Liste des types d'objets qui peuvent etre associés à la photo ou à un fichier attaché. Cette
     * liste
     * ne peut pas etre modifiée par l'utilisateur.
     * généralement, il s'agit des noms des tables (en majuscule + underscore)
     * @param objectTypeIn ObjectType
     */
    public void setObjectType(ObjectType objectTypeIn)
    {
        this.objectType = objectTypeIn;
    }

    /**
     * Returns <code>true</code> if the argument is an GroupingClassification instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof GroupingClassification))
        {
            return false;
        }
        final GroupingClassification that = (GroupingClassification)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link GroupingClassification}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link GroupingClassification}.
         * @return new GroupingClassificationImpl()
         */
        public static GroupingClassification newInstance()
        {
            return new GroupingClassificationImpl();
        }

        /**
         * Constructs a new instance of {@link GroupingClassification}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param label String
         * @param name String
         * @param objectType ObjectType
         * @return newInstance
         */
        public static GroupingClassification newInstance(String label, String name, ObjectType objectType)
        {
            final GroupingClassification entity = new GroupingClassificationImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setObjectType(objectType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link GroupingClassification}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param label String
         * @param name String
         * @param description String
         * @param updateDate Timestamp
         * @param objectType ObjectType
         * @return newInstance GroupingClassification
         */
        public static GroupingClassification newInstance(String label, String name, String description, Timestamp updateDate, ObjectType objectType)
        {
            final GroupingClassification entity = new GroupingClassificationImpl();
            entity.setLabel(label);
            entity.setName(name);
            entity.setDescription(description);
            entity.setUpdateDate(updateDate);
            entity.setObjectType(objectType);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(GroupingClassification o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getLabel() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getLabel().compareTo(o.getLabel()));
            }
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// GroupingClassification.java merge-point
}