// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.order;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Entité de tri.
 * Réprésente une entité (Location, gear, etc.) triée au sein d'un type de tri.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class OrderItem
    implements Serializable, Comparable<OrderItem>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 3425033531408787385L;

    // Generate 4 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Integer objectId;

    /**
     * 
     * @return this.objectId Integer
     */
    public Integer getObjectId()
    {
        return this.objectId;
    }

    /**
     * 
     * @param objectIdIn Integer
     */
    public void setObjectId(Integer objectIdIn)
    {
        this.objectId = objectIdIn;
    }

    private Integer rank;

    /**
     * Numéro d'ordre de l'entité de tri au sein d'un même type d'entité
     * @return this.rank Integer
     */
    public Integer getRank()
    {
        return this.rank;
    }

    /**
     * Numéro d'ordre de l'entité de tri au sein d'un même type d'entité
     * @param rankIn Integer
     */
    public void setRank(Integer rankIn)
    {
        this.rank = rankIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 1 associations
    private OrderType orderType;

    /**
     * Type de tri
     * @return this.orderType OrderType
     */
    public OrderType getOrderType()
    {
        return this.orderType;
    }

    /**
     * Type de tri
     * @param orderTypeIn OrderType
     */
    public void setOrderType(OrderType orderTypeIn)
    {
        this.orderType = orderTypeIn;
    }

    /**
     * Returns <code>true</code> if the argument is an OrderItem instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof OrderItem))
        {
            return false;
        }
        final OrderItem that = (OrderItem)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link OrderItem}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link OrderItem}.
         * @return new OrderItemImpl()
         */
        public static OrderItem newInstance()
        {
            return new OrderItemImpl();
        }

        /**
         * Constructs a new instance of {@link OrderItem}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param objectId Integer
         * @param rank Integer
         * @param orderType OrderType
         * @return newInstance
         */
        public static OrderItem newInstance(Integer objectId, Integer rank, OrderType orderType)
        {
            final OrderItem entity = new OrderItemImpl();
            entity.setObjectId(objectId);
            entity.setRank(rank);
            entity.setOrderType(orderType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link OrderItem}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param objectId Integer
         * @param rank Integer
         * @param updateDate Timestamp
         * @param orderType OrderType
         * @return newInstance OrderItem
         */
        public static OrderItem newInstance(Integer objectId, Integer rank, Timestamp updateDate, OrderType orderType)
        {
            final OrderItem entity = new OrderItemImpl();
            entity.setObjectId(objectId);
            entity.setRank(rank);
            entity.setUpdateDate(updateDate);
            entity.setOrderType(orderType);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(OrderItem o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getObjectId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getObjectId().compareTo(o.getObjectId()));
            }
            if (this.getRank() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRank().compareTo(o.getRank()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// OrderItem.java merge-point
}